import type { Env } from './types';
declare type FilenameGetter = string | ((code?: string) => string);
declare type FilepathGetter = string | ((filename: string) => string);
export declare type OutputOptions = {
    cssFilename: FilenameGetter;
    cssFilepath: FilepathGetter;
};
export default class Output {
    env: Env;
    config: OutputOptions;
    filepath: string;
    constructor({ env, config }: {
        env: Env;
        config?: Partial<OutputOptions>;
    });
    save({ sourceMap, filename }?: {
        sourceMap: any;
        filename: any;
    }): void;
}
export {};
