"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var path=_interopDefault(require("path")),t=require("@babel/types"),assert=_interopDefault(require("assert")),taddy=require("taddy"),standalone=require("@babel/standalone"),register=require("@babel/register"),register__default=_interopDefault(register),evaluatePath=_interopDefault(require("babel-helper-evaluate-path")),resolve=_interopDefault(require("resolve")),tsPreset=_interopDefault(require("@babel/preset-typescript")),reactPreset=_interopDefault(require("@babel/preset-react")),envPreset=_interopDefault(require("@babel/preset-env")),core=require("@babel/core"),core$1=require("@taddy/core"),stringHash=_interopDefault(require("string-hash")),fs=_interopDefault(require("fs")),sourceMap=require("source-map"),convert=_interopDefault(require("convert-source-map"));function _extends(){return(_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var s in r)Object.prototype.hasOwnProperty.call(r,s)&&(e[s]=r[s])}return e}).apply(this,arguments)}function _objectWithoutPropertiesLoose(e,t){if(null==e)return{};var r,s,n={},i=Object.keys(e);for(s=0;s<i.length;s++)t.indexOf(r=i[s])>=0||(n[r]=e[r]);return n}const MACRO_NAME="taddy.macro",PACKAGE_NAME="taddy";function getEnv(e){try{return e.env()}catch(e){}return process.env&&process.env.BABEL_ENV||"production"}function getRootDir(){return process.cwd()}const DEFAULT_CACHE_DIR=path.join(__dirname,"../cache");function getCacheDir(){return DEFAULT_CACHE_DIR}const cache=new WeakMap;class BindingError extends Error{}function isIterable(e){return Symbol.iterator in Object(e)}function addBinding(e,t,r){if(isIterable(r))for(let s of r)addBinding(e,t,s);else e.set(t,(e.get(t)||new Set).add(r))}function isFunctionArgument(e){return"params"===e.listKey&&e.parentPath.isFunction()}function findBindings(e,{throwError:t=!1}={}){function r(r,s,i){s.parentPath.isMemberExpression()?s=s.parentPath.get("object"):s.parentPath.isObjectPattern()&&(s=s.parentPath.parentPath);const{parentPath:o,node:a}=s;if(!(o.isExpression()||o.isSpreadElement()||o.isVariableDeclarator()&&o.node.init===a||o.isObjectProperty()&&(o.node.value===a||o.node.computed)))return;if(!("name"in a)||"string"!=typeof a.name)return;const{name:c}=a,p=e.scope.getBinding(c),l=r.scope.getBinding(c);if(!l)return;if(p!==l)return;if(l.constantViolations.length>0)throw new BindingError("CONSTANT VIOLATION");const{path:u}=l;if(i.has(l))addBinding(i,l,s);else if(isFunctionArgument(u)){if(t)throw new BindingError("FUNCTION ARGUMENT")}else if(addBinding(i,l,s),!u.isImportSpecifier())for(let[e,t]of n(u))addBinding(i,e,t)}const s=new Set;function n(e){if(e.isObjectPattern(),cache.has(e))return cache.get(e);const t=new Map;return s.has(e)||(s.add(e),e.isIdentifier()&&r(e,e,t),e.traverse({Identifier(s){r(e,s,t)}}),cache.set(e,t)),t}return n(e)}function getPathsByBindings(e){const t=new Set;for(let r of e.keys())r.path.isImportSpecifier()||r.path.isVariableDeclarator()?t.add(r.path.parentPath):t.add(r.path);return t}function buildCodeByPath(e){return Array.from(getPathsByBindings(findBindings(e,{throwError:!0}))).sort((e,t)=>e.node.start-t.node.start).map(e=>e.toString()).join("\n")}standalone.registerPreset("@babel/preset-typescript",tsPreset),standalone.registerPreset("@babel/preset-react",reactPreset),standalone.registerPreset("@babel/preset-env",envPreset);const DEFAULT_PRESETS=[["@babel/preset-typescript",{allExtensions:!0,isTSX:!0}],["@babel/preset-env",{targets:{node:"12"},useBuiltIns:!1,ignoreBrowserslistConfig:!0}]],EXTENSIONS=[".es6",".es",".tsx",".ts",".jsx",".js",".mjs"],macroRe=new RegExp(MACRO_NAME.replace(".","\\."),"g"),EVAL_FILENAME_POSTFIX="@__TADDY_EVALUATE__",nodeRequire=new Function("require","return typeof require !== 'undefined'\n        ? require\n        : (typeof globalThis !== 'undefined' ? globalThis : global).require; ")(module.require);function isTaddyEvaluation(e){return e.filename.includes(EVAL_FILENAME_POSTFIX)}function evaluate(e){const t=evaluatePath(e);if(t.confident)return findBindings(e),{value:t.value};let r="",s="";try{const t="__taddy__";r=buildCodeByPath(e).replace(macroRe,PACKAGE_NAME).concat(`\n\n;${t}(${e.toString()})`);const{opts:n}=e.hub.file,i=path.extname(n.filename),o=path.basename(n.filename,i),a=path.dirname(n.filename),c={babelrc:!1,configFile:!1,filename:path.join(a,o+EVAL_FILENAME_POSTFIX+i),plugins:[],presets:[...DEFAULT_PRESETS]};if(({code:s}=standalone.transform(r,c)||{}),!s)return{};const p=new Function("require",t,s);let l;return register__default(_extends({},c,{extensions:EXTENSIONS})),p(e=>{if(e===PACKAGE_NAME)return taddy;const t=resolve.sync(e,{extensions:EXTENSIONS,basedir:path.dirname(n.filename)});return nodeRequire(t)},e=>{l=e}),register.revert(),{value:l}}catch(e){return{error:e}}}function getObjectPropertyKey(e){return e.isIdentifier()?e.node.name:e.isLiteral()&&"value"in e.node?String(e.node.value):null}function mergeObjectProperties(e){const r=new Map;function s(e,t){r.delete(e),r.set(e,t)}for(const r of e){if(!t.isObjectProperty(r)){s(r,r);continue}const{key:e}=r;t.isIdentifier(e)?s(e.name,r):t.isStringLiteral(e)?s(e.value,r):s(r,r)}return Array.from(r.values())}function mergeObjects(e){const t=[];return e.forEach(e=>{t.push(...e.properties)}),mergeObjectProperties(t)}function isTaddy(e){const{path:t}=e;if(!t.isImportSpecifier())return!1;const{imported:r}=t.node;return core.types.isIdentifier(r)&&("taddy"===t.parentPath.node.source.value&&"css"===r.name||"mixin"===r.name)}class BindingOptimizer{constructor(){this.cache=new Map}process(e){let t;try{t=findBindings(e)}catch(e){return}for(let[e,r]of t){if(isTaddy(e))continue;if(e.path.removed)continue;if(this.process(e.path),addBinding(this.cache,e,r),this.cache.get(e).size<e.references)continue;e.path.remove();const{parentPath:t}=e.path;t.isImportDeclaration()&&0===t.node.specifiers.length&&t.remove()}}}function apply(e){let r,s="";for(let n of e)"string"!=typeof n?(r&&s?(r=t.binaryExpression("+",r,t.stringLiteral(" "+s+" ")),r=t.binaryExpression("+",r,n)):r=s?t.binaryExpression("+",t.stringLiteral(s+" "),n):n,s=""):s+=(s?" ":"")+n;return r&&s&&(r=t.binaryExpression("+",r,t.stringLiteral(" "+s))),r||t.stringLiteral(s)}function optimizeStaticStyles(e){const r=[];let s=[];for(const n of e.get("properties")){if(!n.isObjectProperty())throw new Error("Cant optimize this path");const e=getObjectPropertyKey(n.get("key"));if(!e)return;const i=n.get("value");"className"!==e&&"style"!==e&&e!==core$1.VARS_KEY?i.isStringLiteral()?s.push(e+i.node.value):i.isBooleanLiteral()?s.push(e):s.push(t.binaryExpression("+",t.stringLiteral(e),i.node)):(s.length&&r.push(t.objectProperty(apply(s),t.booleanLiteral(!0))),r.push(n.node),s=[])}0!==r.length?(s.length&&r.push(t.objectProperty(apply(s),t.booleanLiteral(!0))),e.node.properties=r):e.replaceWith(apply(s))}function taggedTemplateToObject(e){const t=require("postcss"),r=require("postcss-js"),{quasis:s,expressions:n}=e.node.quasi,i={},o=/@\^var__\w+__/;let a="";for(let e=0;e<s.length;e++)if(a+=s[e].value.raw,n[e]){const t=`@^var__${e}__`;i[t]=n[e],a+=t}const c=t.parse(a);function p(e){const t=[];return e.replace(new RegExp(o,"g"),e=>{t.push(i[e])}),0===t.length?core.types.stringLiteral(e):core.types.templateLiteral(e.split(o).map(e=>core.types.templateElement({raw:e,cooked:e})),t)}return function e(t){const r=[];for(let s in t){const n=t[s];if(!0===n){r.push(core.types.spreadElement(i[s]));continue}const o=p(s.replace(/^&/,""));let a;a="object"==typeof n?e(n):p(String(n)),r.push(core.types.objectProperty(o,a,!core.types.isStringLiteral(o)))}return core.types.objectExpression(r)}(r.objectify(c))}function getType(e){return null==e?void 0:e.getTypeAtLocation(e.getDeclarations()[0])}class DynamicType{constructor({value:e,type:t}){this.value=e,this.type=t}}class UnionType extends Array{}function isRecord(e){var t;return"Record"===(null==e||null===(t=e.getAliasSymbol())||void 0===t?void 0:t.getEscapedName())}const STATIC_KEY=Symbol("__TADDY_STATIC_KEY__");function isStaticValue(e){return!e||"object"!=typeof e||!(e instanceof UnionType)&&(e[STATIC_KEY]||!1)}function filterValue(e){return String(e).startsWith("-")}function parseValue(e){var t;if(!e)return null;if(e.isAny()||e.isUnknown())return new DynamicType({value:null,type:e});if(isRecord(e))return parseRecord(e);if(e.isArray())return parseArray(e);if(e.isUnion())return new UnionType(...e.getUnionTypes().map(parseValue));if(e.isObject())return parseObject(e);let r=null==e?void 0:e.getText();if(!r||(null===(t=r)||void 0===t?void 0:t.includes("&")))return null;try{r=JSON.parse(r)}catch(t){return new DynamicType({value:r,type:e})}return filterValue(r)?null:r}function parseMixinParameters(e){return parseValue(getType(e))}function parseMixin(e){const t=getType(e);return 0===(null==t?void 0:t.getCallSignatures().length)?parseMixinParameters(e):null==t?void 0:t.getCallSignatures()[0].getParameters().map(parseMixinParameters)}function parseRecord(e){const[t,r]=e.getAliasTypeArguments(),s=parseValue(t),n=parseValue(r);return Array.isArray(s)?s.map(e=>({[e]:n,[STATIC_KEY]:n[STATIC_KEY]})):{[s]:n,[STATIC_KEY]:n[STATIC_KEY]}}function parseArray(e){const t=[];function r(e){const r=parseValue(e);if(!r)return;const s=isStaticValue(r);t[STATIC_KEY]=t[STATIC_KEY]&&s,t.push(s?r:new Set([].concat(r).filter(Boolean)))}t[STATIC_KEY]=!0;const s=e.getArrayElementTypeOrThrow();for(let e of s.getUnionTypes()||[s])r(e);return t}function parseObject(e){const t={};let r=!0;for(const n of null!==(s=null==e?void 0:e.getProperties())&&void 0!==s?s:[]){var s;const e=n.getEscapedName(),i=parseMixin(n);if(!i)continue;const o=isStaticValue(i);r=r&&o,t[e]=o?i:new Set([].concat(i).filter(Boolean))}return t[STATIC_KEY]=r,t}class TSProcessor{constructor(e){const{Project:t}=require("ts-morph");this.project=e instanceof t?e:new t(_extends({tsConfigFilePath:path.join(process.cwd(),"tsconfig.json")},e))}getTypeAtPos(e,t,r,s){let n=this.project.getSourceFile(e);return n&&n.getFullText()!==t?n.replaceText([0,n.getEnd()],t):n=this.project.createSourceFile(e,t,{overwrite:!0}),n.getDescendantAtStartWithWidth(r,s-r)}}function isUndefined(e){return e.isIdentifier()&&"undefined"===e.node.name}function getLiteralValue(path){try{return eval(path.toString())}catch(e){return getLiteralValue.FAIL}}function getHashedName(e,{postfix:t}){return core$1.config.nameGenerator.getName(e,"",{postfix:t}).join("")}getLiteralValue.FAIL=Symbol("FAILED_VALUE");const isCSSProperty=e=>"--"===e.slice(0,2)||/[\w-]/.test(e);let cachedTSProject;class Processor{constructor({config:e}){this.config=e}prepare(e){this.options=e,this.variables=[],this.classNameNodes=new WeakSet,this.optimizationPaths=new Set}get tsProject(){if(!this.config.typescript)throw new Error("TADDY: cant use typescript without enabled option");return cachedTSProject||(cachedTSProject=new TSProcessor(!0===this.config.typescript?{}:this.config.typescript))}$css(e,t){return taddy.$css(e,_extends({},t))}isClassNameNode(e){return this.classNameNodes.has(e)}classNamesToNode(e){const r=[];for(const s in e){const n=e[s],i=t.identifier(s);let o;o="object"==typeof e[s]?t.objectExpression(this.classNamesToNode(e[s])):"boolean"==typeof e[s]?t.booleanLiteral(n):t.stringLiteral(String(n));const a=t.objectProperty(i,o);this.classNameNodes.add(a),r.push(a)}return r}stylesToNode(e,t,{postfix:r=""}={}){const{className:s}=this.$css({[e]:t},{postfix:r});return this.classNamesToNode(s)}processPropertyValue(e,r,{postfix:s,properties:n}){const i=r.get("key"),o=r.get("value"),a=Symbol("STOP"),c=e=>{var t;const r=null===(t=this.tsProject)||void 0===t?void 0:t.getTypeAtPos(this.options.filename,this.options.code,e.node.start||0,e.node.end||0);return r?parseValue(r.getType()):a};(()=>{if(!o.isLiteral()&&!isUndefined(o))return!1;const t=getLiteralValue(o);return t!==getLiteralValue.FAIL&&(n.push(...this.stylesToNode(e,t,{postfix:s})),!0)})()||(()=>{if(!o.isObjectExpression())return!1;this.process(o,{postfix:s+e});let r=[];for(const e of o.node.properties)this.isClassNameNode(e)?(r.length&&(n.push(t.objectProperty(i.node,t.objectExpression(r))),r=[]),n.push(e)):r.push(e);return r.length&&n.push(t.objectProperty(i.node,t.objectExpression(r))),!0})()||(()=>{if("composes"!==e||!o.isArrayExpression())return!1;if(""!==s)throw new Error("TADDY: composes could be used only on top level");for(const e of o.get("elements"))this.process(e);return!1})()||(()=>{if(!this.config.evaluate)return!1;const{value:t,error:i}=evaluate(o);return!i&&(n.push(...this.stylesToNode(e,t,{postfix:s})),this.optimizationPaths.add(r),!0)})()||(()=>{if(!this.config.typescript)return!1;let i;if(i="composes"===e&&o.isArrayExpression()?(e=>{const t=[];t[STATIC_KEY]=!0;for(let r of e.get("elements")){if(!r)return;const e=c(r);if(e===a)return;t[STATIC_KEY]=t[STATIC_KEY]&&isStaticValue(e),t.push(e)}return t})(o):c(o),i===a)return!1;if(isStaticValue(i))return n.push(...this.stylesToNode(e,i,{postfix:s})),this.optimizationPaths.add(r),!0;if("composes"===e)return!1;const p=[].concat(i);let l=!0;if(p.forEach(t=>{t instanceof DynamicType||!isStaticValue(t)?l=!1:this.$css({[e]:t},{postfix:s})}),!l)return!1;const u=getHashedName(e,{postfix:s}),f=this.options.addImport("h");return n.push(t.objectProperty(t.identifier(u),t.callExpression(f,[o.node]))),!0})()||(()=>{if(!this.config.CSSVariableFallback)return!1;if(this.options.mixin||"composes"===e||!isCSSProperty(e))return!1;const r="--"+getHashedName(e,{postfix:s});return this.variables.push(t.objectProperty(t.stringLiteral(r),o.node)),n.push(...this.stylesToNode(e,`var(${r})`,{postfix:s})),!0})()||n.push(r.node)}processObjectProperty(e,{postfix:r="",properties:s}){const n=e.get("key"),i=getObjectPropertyKey(n),o=()=>{if(!this.config.evaluate)return!1;const{value:i,error:o}=evaluate(n);return!o&&(n.replaceWith(t.stringLiteral(i)),this.processPropertyValue(i,e,{postfix:r,properties:s}),!0)};if("className"!==i&&"style"!==i&&null!==i)this.processPropertyValue(i,e,{postfix:r,properties:s});else{if(o())return;s.push(e.node)}}processSpreadElement(e,{postfix:t="",properties:r}){(()=>{if(!this.config.evaluate)return!1;const{value:s}=evaluate(e.get("argument"));if(!s)return!1;const{className:n}=this.$css(s,{postfix:t});return r.push(...this.classNamesToNode(n)),this.optimizationPaths.add(e),!0})()||(()=>{var s;if(!this.config.typescript)return!1;const{argument:n}=e.node,i=null===(s=this.tsProject)||void 0===s?void 0:s.getTypeAtPos(this.options.filename,this.options.code,n.start||0,n.end||0);if(!i)return!1;const o=parseValue(i.getType());if(!isStaticValue(o))return!1;const{className:a}=this.$css(o,{postfix:t});return r.push(...this.classNamesToNode(a)),this.optimizationPaths.add(e),!0})()||(this.process(e.get("argument")),r.push(e.node))}processLogicalExpression(e,t){this.process(e.get("left"),t),this.process(e.get("right"),t)}processObjectExpression(e,{postfix:t=""}){const r=[];for(const s of e.get("properties"))s.isObjectProperty()?this.processObjectProperty(s,{postfix:t,properties:r}):s.isSpreadElement()?this.processSpreadElement(s,{postfix:t,properties:r}):r.push(s.node);this.options.mixin||(e.node.properties=mergeObjectProperties(r))}processConditionalExpression(e,t={}){this.process(e.get("consequent"),t),this.process(e.get("alternate"),t)}process(e,t={}){e.isLogicalExpression()?this.processLogicalExpression(e,t):e.isObjectExpression()?this.processObjectExpression(e,t):e.isConditionalExpression()&&this.processConditionalExpression(e,t)}run(e,r){this.prepare(r);const s=e=>{if(!this.config.evaluate)return!1;const{value:r,error:s}=evaluate(e);if(s)return!1;const{className:n}=this.$css(r);if(this.options.mixin)return!0;const i=this.classNamesToNode(n);return e.replaceWith(t.objectExpression(mergeObjectProperties(i))),this.optimizationPaths.add(e),!0};let n=[].concat(e.get("arguments")),i=!0;for(let e of n)s(e)||(this.process(e),e.isObjectExpression()||(i=!1));const o=n.map(e=>e.node),a=n[0];if(this.variables.length>0&&o.push(t.objectExpression([t.objectProperty(t.identifier(core$1.VARS_KEY),t.objectExpression(this.variables))])),i){a.replaceWith(t.objectExpression(mergeObjects(o))),e.node.arguments=[a.node];const r=a,s=r.node.properties.every(e=>!!t.isObjectProperty(e)&&"name"in e.key&&!("_"!==e.key.name[0]&&"className"!==e.key.name&&"style"!==e.key.name&&e.key.name!==core$1.VARS_KEY&&!t.isBooleanLiteral(e.value)));return!this.options.mixin&&s&&optimizeStaticStyles(r),{isStatic:s,optimizationPaths:this.optimizationPaths}}return{isStatic:!1,optimizationPaths:this.optimizationPaths}}}function isPathRemoved(e){do{if(e.removed)return!0}while(e=e.parentPath);return!1}const createHandlers=(e,r)=>{const s=[],n=[],i=[],o=new Processor({config:e}),a=new BindingOptimizer;let c=0;const p=e=>{e.node.arguments.push(t.stringLiteral("__"+stringHash(path.relative(getRootDir(),r.filename)+":"+ ++c).toString(32)))};function l({path:e,mixin:t}){var s;const i=o.run(e,_extends({},r,{mixin:t}));if(!i)return;const{isStatic:a,optimizationPaths:c}=i,l=taddy.$css.ruleInjector.styleSheet.rules.join("").length;console.log(r.state.file.opts.generatorOpts.sourceFileName),r.sourceMapGenerator.addMapping({generated:{line:1,column:l},source:r.state.file.opts.generatorOpts.sourceFileName,original:null===(s=e.node.loc)||void 0===s?void 0:s.start}),n.push({path:e,isStatic:a,optimizationPaths:c}),t||p(e)}return{handlers:{css:(e,{mixin:t=!1}={})=>{e.isMemberExpression()&&"name"in e.node.property&&"mixin"===e.node.property.name?s.push(e.parentPath):e.isCallExpression()&&i.push({path:e,mixin:t})},mixin:e=>{s.push(e)}},finish(){i.forEach(l);let r=!0;for(let t of n)if(r=r&&t.isStatic,e.optimizeBindings)for(let e of t.optimizationPaths)a.process(e);for(let t of s)e.optimizeBindings&&isPathRemoved(t)||(r=!1,l({path:t,mixin:!0}));if(!r)for(let e of n){if(!e.isStatic)continue;const{path:r}=e;r.replaceWith(t.callExpression(t.memberExpression(r.node.callee,t.identifier("static")),r.node.arguments))}return{isStatic:r}}}};let LAST_INDEX=0;function getStylesState(){const{rules:e}=taddy.$css.ruleInjector.styleSheet,t=e.slice(LAST_INDEX);return LAST_INDEX=e.length,{added:[...t].map(e=>e.cssText||"")}}function resolveFilepath(e,...t){return"string"!=typeof e?e(...t):path.join(getRootDir(),e)}function getMtime(e){return Number(fs.statSync(e).mtime)}const filesMap=new Map,contentMap=new Map;function readFileSync(e){let t="";try{const r=getMtime(e);if(filesMap.has(r))return filesMap.get(r);t=fs.readFileSync(e).toString(),filesMap.set(r,t),contentMap.set(t,r)}catch(e){}return t}function appendFile(e,t){fs.appendFileSync(e,t)}taddy.$css.ruleInjector.styleSheet.options.mergeDeclarations=!1;class Output{constructor({env:e,config:t}){this.env=e,this.config=Object.assign({cssFilename:()=>"taddy.css",cssFilepath:e=>path.join(getCacheDir(),e)},t);const r=resolveFilepath(this.config.cssFilename);this.filepath=resolveFilepath(this.config.cssFilepath,r),console.log("filepath",this.filepath)}save({}={}){const e=readFileSync(this.filepath),{added:t}=getStylesState(),r=t.filter(t=>!e.includes(t)).join("");appendFile(this.filepath,r)}}function getGeneratorOpts(e){return e.opts.generatorOpts?e.opts.generatorOpts:e.opts}function makeSourceMapGenerator(e){const t=getGeneratorOpts(e),r=t.sourceFileName,s=new sourceMap.SourceMapGenerator({file:r,sourceRoot:t.sourceRoot});return console.log("root",t.sourceRoot),s.setSourceContent(r,e.code),s}function convertGeneratorToComment(e){return convert.fromObject(e).toComment({multiline:!0})}function mapCompileOptions({evaluate:e=!0,unstable_typescript:t=!1,unstable_CSSVariableFallback:r=!0,unstable_optimizeBindings:s=!0,unstable_useTaggedTemplateLiterals:n=!1}){return{evaluate:e,typescript:t,CSSVariableFallback:r,optimizeBindings:s,useTaggedTemplateLiterals:n}}let output;function macro({references:e,babel:r,state:s,config:n={}}){const{env:i=getEnv(r)}=n,o=_objectWithoutPropertiesLoose(n,["env"]);if(isTaddyEvaluation(s))return;const a=s.file.path,c=s.file.code,{filename:p}=s;let l=null;const u=makeSourceMapGenerator(s.file);taddy.$css.ruleInjector.reset(),a.traverse({ImportDeclaration(e){const{node:r}=e;r.source.value!==PACKAGE_NAME&&r.source.value!==MACRO_NAME||(l=e,l.node.source=t.stringLiteral("taddy"),e.stop())}});const f=new Map,d=mapCompileOptions(_extends({filename:p},o.compileOptions)),{useTaggedTemplateLiterals:h}=d,g=_objectWithoutPropertiesLoose(d,["useTaggedTemplateLiterals"]),{handlers:m,finish:y}=createHandlers(g,{state:s,sourceMapGenerator:u,env:i,filename:p,code:c,addImport(e){if(!f.has(e)){const r=t.importSpecifier(t.identifier(`_${e}_`),t.identifier(e));f.set(e,r),assert(l,"There is no taddy imports"),l.node.specifiers.push(r)}return f.get(e).local}});for(const r in e)if(r in m)for(let s of e[r]){let e=s.parentPath,n=r;if("css"===r&&e.isMemberExpression()&&"name"in e.node.property&&"mixin"===e.node.property.name&&(e=e.parentPath,n="mixin"),h&&("css"===n||"mixin"===n)&&e.isTaggedTemplateExpression()){const r=taggedTemplateToObject(e);e.replaceWith(t.callExpression(e.node.tag,[r]))}m[n](e)}const{isStatic:b}=y();b&&null!==l&&(l.node.source=t.stringLiteral("@taddy/core")),output=output||new Output({env:i,config:o.outputOptions});const E=convertGeneratorToComment(u);return output.save({sourceMap:E,filename:p}),{keepImports:!0}}function getImportNames(e){const t=e.node.local.name;return e.isImportSpecifier()?{localName:t,importedName:e.node.imported.name}:e.isImportDefaultSpecifier()?{localName:t,importedName:"default"}:{localName:t,importedName:"namespace"}}function findReferences(e){const t={};for(let r of e){const{localName:e,importedName:s}=getImportNames(r),n=r.scope.getBinding(e);(null==n?void 0:n.referencePaths)&&(t[s]=n.referencePaths)}return t}function plugin(e,t){const r=getEnv(e);return{name:"taddy",pre(){this.references={}},visitor:{ImportDeclaration(s,n){isTaddyEvaluation(n)||s.node.source.value===PACKAGE_NAME&&(Object.assign(this.references,findReferences(s.get("specifiers"))),(this.references.css||this.references.mixin)&&macro({references:this.references,babel:e,state:n,config:_extends({env:r},t)}))}}}}exports.default=plugin,exports.macro=macro;
//# sourceMappingURL=babel-plugin.cjs.production.min.js.map
